#ifdef _WIN32
	#include <tchar.h>
	#include <conio.h>
#elif (defined __linux__) || (defined _AIX) || (defined __APPLE__)
	typedef char _TCHAR;
	#define _tmain main
#endif

#include <iostream>
using namespace std;

#include "LinkedList1.h"
//---------------------------------------------------------------------------
TListNode::TListNode()
{
	Data = 0;
	nextPtr = NULL;  // dolezite !!!!!!!!!!!!!!!!!!!!!!
}
//---------------------------------------------------------------------------
TListNode::~TListNode()
{
}
//---------------------------------------------------------------------------
TList::TList()
{
	firstPtr = lastPtr = NULL;  // dolezite !!!!!!!!!!!!!!!!!!!!!!
}
//---------------------------------------------------------------------------
TList::~TList()
{
	TListNode *currentPtr = firstPtr, *tempPtr;

	if (!isEmpty()) {
		cout << "\nDealokujeme uzly ...\n";

		while (currentPtr != NULL) {
			tempPtr = currentPtr;
			cout << tempPtr->Data << endl;
			currentPtr = currentPtr->nextPtr;
			delete tempPtr;
		}
		cout << "Vsetky uzly tohto zoznamu su dealokovane.\n";
	}
}
//---------------------------------------------------------------------------
void TList::insert(int data) // vlozi prvok usporiadane od najmensieho po najvacsi
{
	TListNode *newPtr = new TListNode;
	newPtr->Data = data;
	newPtr->nextPtr = NULL;

	if (this->firstPtr == NULL)
		this->firstPtr = this->lastPtr = newPtr;
	else
		if (data < this->firstPtr->Data) {
			newPtr->nextPtr = this->firstPtr;
			this->firstPtr = newPtr;
		}
		else if (data > this->lastPtr->Data) {
			this->lastPtr->nextPtr = newPtr;
			this->lastPtr = newPtr;
		}
		else {
			TListNode *p1 = this->firstPtr, *p2 = this->firstPtr->nextPtr;
			while (p2->Data < data) {
				p1 = p2;
				p2 = p2->nextPtr;
			}
			p1->nextPtr = newPtr;
			newPtr->nextPtr = p2;
		}
}
//---------------------------------------------------------------------------
void TList::include(TList* z)
{
	TListNode *p = z->firstPtr;

	while (p != NULL) {
		this->insert(p->Data);
		p = p->nextPtr;
	}
}
//---------------------------------------------------------------------------
ostream& operator<<(ostream& os, const TList* z)
{
	if (z->isEmpty()) {
		os << "Zoznam je prazdny!" << endl;
		return os; 							// ak je zoznam prazdny, koncime
	}
	TListNode *p = z->getFirstPtr(); // pomocny prvok typu TPrvok
	while (p->getNextPtr() != NULL)  // prechdzaj cez vsetky prvky
	{
		os << p->getData() << " ";    // vypis datovu cast prvku
		p = p->getNextPtr(); 		   // chod na dalsi prvok
	}
	os << p->getData(); 		         // vypis posledny prvok
	return os;
}
//---------------------------------------------------------------------------
