//---------------------------------------------------------------------------
#ifndef MaticaObdlznikovaH
#define MaticaObdlznikovaH
//---------------------------------------------------------------------------
#define MAXLINE 255

class TMaticaObdlznikova    // too many const
{
protected:
	unsigned PocetRiadkov,PocetStlpcov;
	long double **Matica;
public:
	TMaticaObdlznikova();
	TMaticaObdlznikova(const unsigned, const unsigned);
	TMaticaObdlznikova(TMaticaObdlznikova&);
	~TMaticaObdlznikova();
	TMaticaObdlznikova& operator=(const TMaticaObdlznikova&);

	friend const TMaticaObdlznikova operator+(const TMaticaObdlznikova&,
		const TMaticaObdlznikova&);
	friend const TMaticaObdlznikova operator*(const TMaticaObdlznikova&,
		const TMaticaObdlznikova&);
	TMaticaObdlznikova& operator+=(const TMaticaObdlznikova&);
	TMaticaObdlznikova& operator*=(const TMaticaObdlznikova&);

	friend istream& operator>>(istream&,TMaticaObdlznikova&);
	friend ostream& operator<<(ostream&,const TMaticaObdlznikova&);

	unsigned getPocetRiadkov() const {return PocetRiadkov;};
	unsigned getPocetStlpcov() const {return PocetStlpcov;};
	long double getPrvokMatice(const unsigned i,const unsigned j) const 
		{return Matica[i][j];};
};

struct my_class { void my_getch() const; };
//---------------------------------------------------------------------------
#endif
