//---------------------------------------------------------------------------
#ifndef LinkedList1H
#define LinkedList1H
//---------------------------------------------------------------------------
class TListNode {
	friend class TList;
private:
	int Data; // Cvicenie: skuste miesto int vlozit sablonu
	TListNode *nextPtr;
public:
	TListNode();
	~TListNode();
	int getData() const { return Data; };  // koli  pretazeniu <<
	TListNode* getNextPtr() const { return nextPtr; }; // koli  pretazeniu <<
};

class TList {
	TListNode *firstPtr;
	TListNode *lastPtr;
public:
	TList();
	~TList();
	void insert(int);
	void include(TList*);
	bool isEmpty() const { return firstPtr == NULL; }; // inline metoda
	TListNode* getFirstPtr() const { return firstPtr; }; // koli  pretazeniu <<
	friend ostream& operator<<(ostream& os, const TList* z);
};
#endif